# (c) Copyright 2012. CodeWeavers, Inc.
# 
# Handles usage logging  
#


import os
import cxlog
import cxproduct

#####
#
# Usage logging
#
#####

def log_usage(s):
    """Append a string to the usage log.
    """
    cxconfig = cxproduct.get_config()

    if cxconfig['CrossOver'].get('ReportWineUsage', 1):
        # If usage reporting is either unset or '1',
        # collect data.  The reporting tool will only send
        # data if the flag is actually set to '1'.
        # Any time the user sets the flag to '0', all 
        # previously collected data is deleted.
        # So: we collect in the case where it's unset *or* 
        # in the case where it's set to '1'; report
        # only in the case where it's set to '1'; and
        # delete in the case where it's set to '0'
        # (the wine script will handle the deleting, so 
        #  we needn't do that here.)
        try:                                                                
            logfile_path = os.path.join(cxproduct.get_user_dir(), "usage.log")
            logfile = os.open(logfile_path, os.O_APPEND | os.O_WRONLY | os.O_CREAT)
            os.write(logfile, s)
        except OSError, e:
            cxlog.warn("I/O error trying to do logging of '%s' to '%s'" % (s, logfile_path))
            cxlog.warn("  loging I/O error details: fd - %d (%d) - %s" % (logfile, e.errno, e.args)) 
        finally:
            os.close(logfile)                                                                
    return
